.( FORTH SCREEN EDITOR         )
CR
.( PROF. ANTONIO COSTA         )
CR
.( MICRO SISTEMAS NR.51 - 1985 )
CR
.( >> WAIT FOR COMPILATION  << )
CR                              
                                
   23 CONSTANT LAST-LINE        
   31 CONSTANT LAST-COLUMN      
   24 CONSTANT NUMBER-OF-LINES  
   32 CONSTANT NUMBER-OF-COLUMNS
    0 CONSTANT FIRST-LINE       
    0 CONSTANT FIRST-COLUMN     
  128 CONSTANT CURSOR-SYMBOL    
   21 CONSTANT NUMBER-SCREENS   
  768 CONSTANT CHARS/SCREEN     
32768 CONSTANT INIBUF           
    0 VARIABLE POINTER          
    0 VARIABLE START-OF-TEXT    
    0 VARIABLE LINE             
    0 VARIABLE COLUMN

: PTC SWAP 33 * + 16530 +       
      17339 ! ;                 
: ENTER? DUP 13 = ;             
: RIGHTARROW DUP 3 = ;          
: LEFTARROW DUP 2 = ;           
: DOWNARROW DUP 4 = ;           
: UPARROW DUP 1 = ;             
: INSDEL DUP 08 = ;             
: OUT? DUP 27 = ;               
: START-LINE POINTER @          
  NUMBER-OF-COLUMNS /           
  NUMBER-OF-COLUMNS * ;         
: CHARACTER  START-OF-TEXT @    
  POINTER @ + C@ ;              
: PUT-CURSOR  LINE @ COLUMN @   
  PTC ;                         
: SHOW-CURSOR PUT-CURSOR        
  CURSOR-SYMBOL EMIT ;          
: SHOW-CHAR PUT-CURSOR CHARACTER
  EMIT ;                        
: ADVANCE COLUMN @ LAST-COLUMN <
  IF 1 COLUMN +!   1 POINTER +! 
  THEN ;
: FORWARD ADVANCE DROP ;        
: STORE START-OF-TEXT @ POINTER 
  @ + C! SHOW-CHAR ADVANCE ;    
: BACKWARD DROP                 
  COLUMN @ FIRST-COLUMN >       
  IF -1 COLUMN +! -1 POINTER +! 
  THEN ;                        
: NEXT-LINE DROP                
  LINE @ LAST-LINE <            
  IF 1 LINE +! NUMBER-OF-COLUMNS
     POINTER +!                 
  THEN ;                        
: BACK-LINE FIRST-COLUMN        
  COLUMN ! START-LINE POINTER ! 
  NEXT-LINE ;                   
: PREVIOUS-LINE DROP            
  LINE @ FIRST-LINE >           
  IF -1 LINE +!                 
   POINTER @ NUMBER-OF-COLUMNS -
   POINTER !                    
  THEN ;
: SHOW-LINE LINE @ 0 PTC        
  START-LINE START-OF-TEXT @ +  
  NUMBER-OF-COLUMNS 0           
  DO  DUP C@ EMIT 1+ LOOP DROP  
;                               
: SHOW-TEXT 0 0 PTC             
  START-OF-TEXT @               
  CHARS/SCREEN 1- 0             
  DO DUP C@ EMIT 1+ LOOP DROP ;  
: INSERT DROP BL                
  NUMBER-OF-COLUMNS COLUMN @ -  
  1 - DUP POINTER @             
  START-OF-TEXT  @ + + SWAP     
  ?DUP IF 0 DO DUP 1 - C@ OVER  
          C! 1- LOOP            
       THEN   C! SHOW-LINE 0 ;  
: DELETE DROP BL                
  POINTER @ START-OF-TEXT @ +   
  NUMBER-OF-COLUMNS COLUMN @ -  
  1- ?DUP                       
  IF 0 DO DUP DUP 1+ C@ SWAP    
          C! 1+ LOOP            
  THEN C! SHOW-LINE 0 ;         
: INS-DEL   DROP                
  BEGIN  KEY RIGHTARROW          
    IF INSERT                   
    ELSE LEFTARROW              
         IF DELETE              
         ELSE DROP 1 THEN THEN  
  UNTIL ;                       
: EDITIONS SHOW-CHAR            
  ENTER?                        
  IF BACK-LINE                  
  ELSE DOWNARROW                
      IF NEXT-LINE              
      ELSE UPARROW              
        IF PREVIOUS-LINE        
        ELSE RIGHTARROW         
          IF FORWARD            
          ELSE LEFTARROW        
            IF BACKWARD         
            ELSE INSDEL         
                 IF INS-DEL     
                 ELSE STORE     
  THEN THEN THEN THEN THEN THEN 
;
: CLR                           
  START-OF-TEXT @ CHARS/SCREEN 0
  DO BL OVER C! 1+ LOOP DROP ;  
: START 0 LINE !  0 COLUMN !    
  0 POINTER ! ( 15 EMIT)        
  SHOW-TEXT ;                   
: ED START                      
  BEGIN SHOW-CURSOR KEY         
    OUT? IF DROP 1              
         ELSE EDITIONS 0 THEN   
  UNTIL  CLS ;                  
: FINDADDR                      
  DUP 1 < IF QUESTION THEN      
  DUP NUMBER-SCREENS >          
  IF QUESTION THEN              
  CHARS/SCREEN 1+ SWAP 1 - *    
  INIBUF + START-OF-TEXT ! ;    
: EDIT                          
  FINDADDR ED                    
  0 START-OF-TEXT @ CHARS/SCREEN
  + C! ;                        
: CLEAR FINDADDR CLR ;          
: FORTH   FINDADDR START-OF-TEXT
          @ LOAD ;              

CR
.( TYPE "N CLEAR" TO CLEAR THE  ) CR
.( SCREEN "N" AND "N EDIT" FOR  ) CR
.( EDIT SCREEN "N".             ) CR
.( CURSOR CAN BE MOVED THROUGH  ) CR
.( THE SCREEN WITH ARROWS KEYS. ) CR
.( TO INSERT SPACES OR DELETE   ) CR
.( CHARACTERS AT ONE POINT OF   ) CR
.( LINE, USE THE "RUBOUT" KEY.  ) CR
.( THE CURSOR WILL LEAVE AND THE) CR
.( RIGHT ARROW INSERT SPACES    ) CR
.( AND LEFT ARROW DELETE CHARAC-) CR
.( TER AT CURSOR POSITION. ANY  ) CR
.( OTHER KEY RETURNS TO EDITING ) CR
.( MODE. TO FINISH THE EDITION, ) CR
.( USE "SHIFT-BREAK".           ) CR
.( TO COMPILE A SCREEN, USE     ) CR
.( "N FORTH", WHERE "N" IS THE  ) CR
.( SCREEN TO BE COMPILED.       ) CR 